# coding: utf-8

"""
    Selling Partner API for Notifications

    The Selling Partner API for Notifications lets you subscribe to notifications that are relevant to a selling partner's business. Using this API you can create a destination to receive notifications, subscribe to notifications, delete notification subscriptions, and more.  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class EventBridgeResourceSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'region': 'str',
        'account_id': 'str'
    }

    attribute_map = {
        'region': 'region',
        'account_id': 'accountId'
    }

    def __init__(self, region=None, account_id=None):  # noqa: E501
        """EventBridgeResourceSpecification - a model defined in Swagger"""  # noqa: E501
        self._region = None
        self._account_id = None
        self.discriminator = None
        self.region = region
        self.account_id = account_id

    @property
    def region(self):
        """Gets the region of this EventBridgeResourceSpecification.  # noqa: E501

        The AWS region in which you will be receiving the notifications.  # noqa: E501

        :return: The region of this EventBridgeResourceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._region

    @region.setter
    def region(self, region):
        """Sets the region of this EventBridgeResourceSpecification.

        The AWS region in which you will be receiving the notifications.  # noqa: E501

        :param region: The region of this EventBridgeResourceSpecification.  # noqa: E501
        :type: str
        """
        if region is None:
            raise ValueError("Invalid value for `region`, must not be `None`")  # noqa: E501

        self._region = region

    @property
    def account_id(self):
        """Gets the account_id of this EventBridgeResourceSpecification.  # noqa: E501

        The identifier for the AWS account that is responsible for charges related to receiving notifications.  # noqa: E501

        :return: The account_id of this EventBridgeResourceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this EventBridgeResourceSpecification.

        The identifier for the AWS account that is responsible for charges related to receiving notifications.  # noqa: E501

        :param account_id: The account_id of this EventBridgeResourceSpecification.  # noqa: E501
        :type: str
        """
        if account_id is None:
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EventBridgeResourceSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EventBridgeResourceSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
